// 004 u_gof_builder
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_gof_builder;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    create_standard_maze_: TButton;
    create_counting_maze_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure create_standard_maze_Click(Sender: TObject);
    procedure create_counting_maze_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

    var Form1: TForm1;

  implementation
    uses u_types_constants, u_c_log, u_c_display
        , u_dir, u_file

        , u_c_maze_2
        , u_c_maze_builder_2
        , u_c_maze_game_2

        , u_c_standard_maze_builder_2
        , u_c_counting_maze_builder_2
    ;

    {$R *.DFM}

 
    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.create_standard_maze_Click(Sender: TObject);
      var l_c_standard_maze_builder: c_standard_maze_builder;
          l_c_maze_game: c_maze_game;
          l_c_maze: c_maze;
      begin
        l_c_standard_maze_builder:= c_standard_maze_builder.create_standard_maze_builder;
        l_c_maze_game:= c_maze_game.create_maze_game;

        l_c_maze:= l_c_maze_game.f_c_create_maze_n(l_c_standard_maze_builder);
        // ...
      end; // create_standard_maze_Click

    procedure TForm1.create_counting_maze_Click(Sender: TObject);
      var l_c_counting_maze_builder: c_counting_maze_builder;
          l_c_maze_game: c_maze_game;
          l_room_count, l_door_count: Integer;
      begin
        l_c_counting_maze_builder:= c_counting_maze_builder.create_counting_maze_builder;
        l_c_maze_game:= c_maze_game.create_maze_game;

        l_c_maze_game.f_c_create_maze_n(l_c_counting_maze_builder);

        l_c_counting_maze_builder.get_room_and_door_count(l_room_count, l_door_count);
        // ...
      end; // create_counting_maze_Click

end.


