// 004 u_c_counting_maze_builder_2
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

// -- does not build a maze: just count the pieces

unit u_c_counting_maze_builder_2;
  interface
    uses u_c_maze_2
        , u_c_maze_builder_2
        ;

    type c_counting_maze_builder= class(c_maze_builder)
                                    _m_door_count, _m_room_count: Integer;

                                    Constructor create_counting_maze_builder;

                                    procedure build_maze; Override;
                                    procedure build_room(p_room_number: Integer); Override;
                                    procedure build_door(p_from_room_number, p_to_room_number: Integer); Override;
                                    procedure add_wall(p_wall_number: Integer; p_direction: t_direction); Virtual;

                                    procedure get_room_and_door_count(var pv_room_count, pv_door_count: Integer);
                                    function f_c_maze: c_maze; Override;
                                  end; // c_counting_maze_builder

  implementation

    // -- c_counting_maze_builder

    Constructor c_counting_maze_builder.create_counting_maze_builder;
      begin
        Inherited Create;
      end; // create_counting_maze_builder

    procedure c_counting_maze_builder.build_maze;
      begin
        // _m_c_current_maze:= c_maze.create_maze;
      end; // build_maze

    procedure c_counting_maze_builder.build_room(p_room_number: Integer);
      begin
        Inc(_m_room_count);
      end; // build_room

    procedure c_counting_maze_builder.build_door(p_from_room_number, p_to_room_number: Integer);
      begin
        Inc(_m_door_count);
      end; // build_door

    procedure c_counting_maze_builder.add_wall(p_wall_number: Integer; p_direction: t_direction);
      begin
      end; // add_wall

    procedure c_counting_maze_builder.get_room_and_door_count(var pv_room_count, pv_door_count: Integer);
      begin
        pv_room_count:= _m_room_count;
        pv_door_count:= _m_door_count;
      end; // get_room_and_door_count

    function c_counting_maze_builder.f_c_maze: c_maze;
      begin
        // -- the c_counting_maze_builder does NOT build a maze
        // -- the function is here only to avoid a compiler warning
        Result:= Nil;
      end; // f_c_maze

    begin // u_c_counting_maze_builder
    end. // u_c_counting_maze_builder

