// 002 u_c_maze_game_2
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_c_maze_game_2;
  interface
    uses u_c_maze_2, u_c_maze_builder_2;

    type c_maze_game= Class
                        constructor create_maze_game;
                        function f_c_create_maze_2(p_c_maze_builder: c_maze_builder): c_maze;
                        function f_c_create_maze_n(p_c_maze_builder: c_maze_builder): c_maze;
                      end; // c_maze_game

  implementation
    uses SysUtils, u_c_display;

    // -- c_maze_game

    constructor c_maze_game.create_maze_game;
      begin
        Inherited;
      end; // create_maze_game

    function c_maze_game.f_c_create_maze_2(p_c_maze_builder: c_maze_builder): c_maze;
      begin
        with p_c_maze_builder do
        begin
          build_maze;
          build_room(1);
          build_room(2);

          build_door(1, 2);

          Result:= f_c_maze;
        end; // with p_c_maze_builder
      end; // create_maze_game

    function c_maze_game.f_c_create_maze_n(p_c_maze_builder: c_maze_builder): c_maze;
      begin
        with p_c_maze_builder do
        begin
          build_maze;

          build_room(1);
          build_room(2);
          build_room(3);

          build_door(1, 2);
          // ...

          Result:= f_c_maze;
        end; // with p_c_maze_builder
      end; // f_c_create_maze_n

  end. // u_c_maze


